;; refer Table3D.dwg
;; Trial Run
;; Command: tafel <Enter>

;; Specify Thickness of Legs:1 <Enter>
;; Specify Height of Legs:4 <Enter>
;; Specify Length of Table:8 <Enter>
;; Specify Width of Table:6 <Enter>
;; Specify Thickness of Desktop:1 <Enter>
;; Click or Type the coordinates of Begining point: Click Somewhere with the mouse

(defun c:tbl()
  (setq tlegs (getreal "Specify Thickness of Legs:"))
  (setq hlegs (getreal "Specify Height of Legs:"))
  (setq length-of-table (getreal "Specify Length of Table:"))
  (setq width-of-table (getreal "Specify Width of Table:"))
  (setq thickness-of-desktop (getreal "Specify Thickness of Desktop:"))
  ;(setq table-type (getint "1 = Rectangular Legs, 2 = Cylindrical Legs of Table:"))
  (setq p1 (getpoint "Click or Type the coordinates of Begining point:"))

  ;; get the x-coordinate of the other corner of the table
  (setq p3x (+ (car p1) length-of-table))

  ;; get the y-coordinate of the other corner of the table
  (setq p3y (+ (cadr p1) width-of-table))

  ;; create point p3 - the other corner
  (setq p3 (list p3x p3y))

  ;; create point p2
  (setq p2 (list p3x (cadr p1)))

  ;; create point p4
  (setq p4 (list (car p1) p3y))
  
  ;; use the polyline command to draw the rectangle
  (command "pline" p1 p2 p3 p4 p1 "")

  ;; extrude the polyline - the last object created
  (command "extrude" "l" "" thickness-of-desktop 0)

  ;; do the same thing for the leg rectangle

  ;; first corner of the leg - rectangle is at p1
  (setq p1-leg p1)
  
  ;; get the x-coordinate of the other corner of the leg
  (setq p3x-leg (+ (car p1-leg) tlegs))

  ;; get the y-coordinate of the other corner of the leg
  (setq p3y-leg (+ (cadr p1-leg) tlegs))

  ;; create point p3-leg : the other corner of the leg rectangle
  (setq p3-leg (list p3x-leg p3y-leg))

  ;; create point p2-leg
  (setq p2-leg (list p3x-leg (cadr p1-leg)))

  ;; create point p4
  (setq p4-leg (list (car p1-leg) p3y-leg))
  
  ;; use the polyline command to draw the rectangle
  (command "pline" p1-leg p2-leg p3-leg p4-leg p1-leg "")

  ;; extrude the polyline - the last object created
  ;; multiply by -1 to extrude leg below table-desktop
  (command "extrude" "l" "" (* hlegs -1) 0)
  
  ;; now copy the leg from p2-leg to p2 : "l" stands for the last created object
  (command "copy" "l" "" p2-leg p2 "")

  ;; copy leg from p4-leg to p4 : "p" stands for previously picked object
  (command "copy" "p" "" p4-leg p4 "")
  
  ;; copy leg from p3-leg to p3
  (command "copy" "p" "" p3-leg p3 "")

  ;; put a semicolon in front of the next two commands
  ;; if you don't want automatic 3d-view & Gouraud shading

  (command "vpoint" "r" 225 30)
  (command "shademode" "g")

  ;; do not remove this line
  (command "zoom" "extents")
  
)
